Subject: Re: [PATCH v3 4/7] remote: add remote.*.negotiationRestrict config

From: Derrick Stolee <[email-masked]>
Date: Tue, 12 May 2026 10:52:38 -0400

On 5/12/26 8:29 AM, Matthew John Cheetham wrote:
> On 2026-04-22 16:25, Derrick Stolee via GitGitGadget wrote:
> 
>> From: Derrick Stolee<[email-masked]>
>>
>> In a previous change, the --negotiation-restrict command-line option of
>> 'git fetch' was added as a synonym of --negotiation-tips. Both of these
>> options restrict the set of 'haves' the client can send as part of
>> negotiation.
> 
> s/tips/tip/ as per the previous patch comments. Not important either
> way.

Thanks.

>> +remote.<name>.negotiationRestrict::
>> +    When negotiating with this remote during `git fetch` and `git push`,
>> +    restrict the commits advertised as "have" lines to only those
>> +    reachable from refs matching the given patterns.  This multi-valued
>> +    config option behaves like `--negotiation-restrict` on the command
>> +    line.
>> ++
>> +Each value is either an exact ref name (e.g. `refs/heads/release`) or a
>> +glob pattern (e.g. `refs/heads/release/*`).  The pattern syntax is the
>> +same as for `--negotiation-restrict`.
>> ++
>> +These config values are used as defaults for the `--negotiation-restrict`
>> +command-line option.  If `--negotiation-restrict` (or its synonym
>> +`--negotiation-tip`) is specified on the command line, then the config
>> +values are not used.
>> ++
>> +Blank values signal to ignore all previous values, allowing a reset of
>> +the list from broader config scenarios.
>> +
>>   remote.<name>.followRemoteHEAD::
>>       How linkgit:git-fetch[1] should handle updates to `remotes/<name>/HEAD`
>>       when fetching using the configured refspecs of a remote.
> 
> 
> You say "during `git fetch` and `git push`", but does `push` actually
> honour the new config?
> 
> When the `push.negotiate` config is on then
> `get_commons_through_negotiation()` from send-pack.c shells out to
> `git fetch --negotiate-only` with one `--negotiation-tip=<oid>` arg per
> ref being pushed, then the URL. This means the CLI restrict list is
> always non-empty in the subprocess so in `prepare_transport()` (in the
> below hunk) the `if (negotiation_restrict.nr)` arm is always taken and the new 
> `else if (remote->negotiation_restrict.nr)` arm is never taken.
> 
> BUT.. reading ahead I see that patch 7 actually wires up negotiation
> config for push - so my commentary here will be moot! Do we want to drop
> the "and `git push`" part from this until patch 7, when it is wired up
> appropriately?

You're right that this documentation is premature about 'git push'.

> One other suggestion: perhaps we should clarify that `push.negotiate`
> needs to be set for `remote.<name>.negotiationRestrict` to be honoured
> during pushes?

Yes. I'll rewrite this to focus on 'git fetch'. Then in patch 7 I can
add a new detail about how to make this behavior be respected in 'git push'.

>>       if (deepen_relative) {
>>           if (deepen_relative < 0)
>>               die(_("negative depth in --deepen is not supported"));
>> @@ -2749,6 +2758,10 @@ int cmd_fetch(int argc,
>>           if (!remote)
>>               die(_("must supply remote when using --negotiate-only"));
>>           gtransport = prepare_transport(remote, 1, &filter_options);
>> +        if (!gtransport->smart_options ||
>> +            !gtransport->smart_options->negotiation_restrict_tips)
>> +            die(_("%s needs one or more %s"), "--negotiate-only",
>> +                "--negotiation-restrict=*");
>>           if (gtransport->smart_options) {
>>               gtransport->smart_options->acked_commits = &acked_commits;
>>           } else {
> 
> 
> This new condition fires whenever `gtransport->smart_options` is NULL,
> i.e. the transport doesn't support smart options. Before this case was
> handled three lines after this hunk by:
> 
>    } else {
>        warning(_("protocol does not support --negotiate-only, exiting"));
>        result = 1;
>        trace2_region_leave("fetch", "negotiate-only", the_repository);
>        goto cleanup;
>    }
> 
> What happens now if a user runs --negotiate-only against a non-smart
> transport is they see an odd message:
> 
>    fatal: --negotiate-only needs one or more --negotiation-restrict=*
> 
> ..but they may have specified --negotiation-restrict options.
> 
> Do we instead want &&?
> 
>       if (gtransport->smart_options &&
>           !gtransport->smart_options->negotiation_restrict_tips)
>           die(_("%s needs one or more %s"), "--negotiate-only",
>               "--negotiation-restrict=*");
You are right that we want to say "we have smart options but haven't
specified restrict arguments" so we can leave the later if/else to
handle the null smart_options case. But actually, I think that it
would be better to reorganize the conditions altogether:

	if (!gtransport->smart_options) {
		warning(_("protocol does not support --negotiate-only, "exiting"));
		result = 1;
		trace2_region_leave("fetch", "negotiate-only", the_repository);
		goto cleanup;
	}
	if (!gtransport->smart_options->negotiation_restrict_tips)
		die(_("%s needs one or more %s"), "--negotiate-only",
		    "--negotiation-restrict=*");

	gtransport->smart_options->acked_commits = &acked_commits;

This is easier to reason about:

* If we don't have smart options, then skip out of the negotiation logic.
* If we don't have restrict tips, then die().
* Do the negotiation logic only if the previous two conditions didn't hold.

>> @@ -562,6 +564,12 @@ static int handle_config(const char *key, const char *value,
>>       } else if (!strcmp(subkey, "serveroption")) {
>>           return parse_transport_option(key, value,
>>                             &remote->server_options);
>> +    } else if (!strcmp(subkey, "negotiationrestrict")) {
>> +        /* reset list on empty value. */
>> +        if (!value || !*value)
>> +            string_list_clear(&remote->negotiation_restrict, 0);
>> +        else
>> +            string_list_append(&remote->negotiation_restrict, value);
>>       } else if (!strcmp(subkey, "followremotehead")) {
>>           const char *no_warn_branch;
>>           if (!strcmp(value, "never"))
> 
> 
> Here we use the 'empty value means reset the list' pattern, but I notice
> that the `parse_transport_option()` function already supports this reset
> pattern (and used by serveroption above), with a small difference:
> 
>    if (!value)
>        return config_error_nonbool(var);
>    if (!*value)
>        string_list_clear(transport_options, 0);
> 
> So NULL is an error, but empty string is 'reset'. Is it worth being
> consistent with other options that use `parse_transport_options`?

Thanks for catching this! Let's be consistent. NULL is likely
impossible in this case, but let's be consistent. It also needs
to return.

Thanks,
-Stolee